//+------------------------------------------------------------------+
//|                                               SuperNightMare.mq4 |
//|                                    Copyright 2012 Abu            |  
//|                                                                  |
//+------------------------------------------------------------------+
extern double longTradeTP = 100;
extern double ShortTradeTP = 100;
extern double LongTradeStopLoss = 150;
extern double ShortTradeStopLoss = 150;
extern string Name_Expert = "SuperNightMare";
extern int    Slippage = 1;
extern bool   UseSound = false;
extern double LotSize = 0.1;
extern double Maxorders = 5;
extern double SafetyPercent = 20;
extern int    ExtDepth       = 12;

extern string moneymanagement="Money Management";
extern double Lots=0.1;                  // lots size
extern bool mm=true;                    // enable risk management
extern double risk=1;                    // risk in percentage of the account
extern double minlot=0.1;               // minimum lots size
extern double maxlot=1;                // maximum lots size
extern double lotdigits=2;               // lot digits, 1 for mini, 2 for micro
extern bool basketpercent=true;         // enable the basket percent
extern double profit=5;                 // close all orders if a profit of 5 percents has been reached
extern double loss=20;                   // close all orders if a loss of 20 percents has been reached

extern string ordersmanagement="Order Management";

extern bool    isbrokerecn=false;        // set true if broker is ecn type
extern bool    timeout=false;            // closes the orders if they don't reach their tp within the next timeminutes
extern double  timeminutes=30;           // time minutes for the timeout
extern bool    maxtradesperpair=true;   // allow on maxtradespercent of the max orders for each type
extern double  maxtradespercent=50;      // max trades percent
extern double  pipstep=0;                // open orders pipstep pips over/under the last one.
extern bool    hidesl=false;             // hide stop loss
extern bool    hidetp=false;             // hide take profit
extern double  lstoploss=0;              // stoploss for long trades
extern double  sstoploss=0;              // stoploss for short trades
extern bool    dynamicsl=false;          // determine stop loss based on multiples of atr()
extern int     atrperiod=14;             // default atr period
extern double  atrmultiple=1.0;          // multiple of atr to use for dynamic sl
extern int     atrtimeframe=1440;        // timeframe for atr, default is 1 day
extern int     atrshift=1;               // shift for determining value of ATR
extern double  ltakeprofit=5;           // takeprofit for long trades
extern double  stakeprofit=5;           // takeprofit for short trades
extern double  ltrailingstop=50;         // trailing stop for long trades
extern double  strailingstop=50;         // trailing stop for short trades
extern int     slippage=1;               // slippage

extern string entrylogics="Entry Logics";

void deinit() 
   {
   Comment("");
   }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int start()
   {

   if(Bars<50)
      {
      Print("bars less than 50");
      return(0);
      }

   if(longTradeTP<1)
      {
      Print("TakeProfit less than 1");
      return(0);
      }

   if(ShortTradeTP<1)
      {
      Print("TakeProfit less than 1");
      return(0);
      }
   
   bool a=false;  int b;
   int shift, BlueArrowIndex, RedArrowIndex, Index = 0;
   double zag, zig; b=0; 
   
   while(a<2) 
      {
      if(zig>0) zag=zig;
      zig=iCustom(NULL, 0, "ZigZag", 0, b);
      if(zig>0) a+=1;
      b++;
      
      for(shift=Bars-1; shift>=0; shift--)
      
      double ZigZagHigh=iCustom(NULL,0,"ZigZag",MODE_HIGH,0);
      double ZigZagLow=iCustom(NULL,0,"ZigZag",MODE_LOW,0);    
      double LowestBar=Low[Lowest(NULL,0,MODE_LOW,ExtDepth,shift)];
      double HighestBar=High[Highest(NULL,0,MODE_HIGH,ExtDepth,shift)];
      double diClose0=iClose(NULL,5,0);
      double diMA1=iMA(NULL,5,5,0,MODE_EMA,PRICE_OPEN,1);
      double diClose2=iClose(NULL,5,0);
      double diMA3=iMA(NULL,5,4,0,MODE_EMA,PRICE_OPEN,1);
      double lowestbid=iLow(NULL,0,LowestBar);
      double highestbid=iHigh(NULL,0,HighestBar);
      
      if(AccountFreeMargin()<(SafetyPercent/100)*AccountBalance())
         {
         Print("We have no money. Free Margin = ", AccountFreeMargin());
         return(0);
         }
      }

  
   if (!ExistPositions())
      {
      if(diClose0<diMA1 && (ZigZagLow) )
         {
         OpenBuy();
         return(0);
         }
      else //
         {
         if(diClose2>diMA3 && (ZigZagHigh))
            {
            OpenSell();
            return(0);
            }
         }
      }  
   }

bool ExistPositions() 
   {
   for (int i=100; i<OrdersTotal(); i++) 
      {
      if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) 
         {
         if (OrderSymbol()==Symbol()) 
            {
            return(True);
            }
         } 
      } 
   return(false);
   }

void OpenBuy() 
   { 
   double ldLot, ldStop, ldTake; 
   string lsComm; 
   ldLot = GetSizeLot(); 
   ldStop = GetStopLossBuy(); 
   ldTake = GetTakeProfitBuy(); 
   lsComm = GetCommentForOrder(); 
   OrderSend(Symbol(),OP_BUY,ldLot,Ask,Slippage,ldStop,ldTake,lsComm,0,0); 
 
   } 

void OpenSell() 
   { 
   double ldLot, ldStop, ldTake; 
   string lsComm; 
   ldLot = GetSizeLot(); 
   ldStop = GetStopLossSell(); 
   ldTake = GetTakeProfitSell(); 
   lsComm = GetCommentForOrder(); 
   OrderSend(Symbol(),OP_SELL,ldLot,Bid,Slippage,ldStop,ldTake,lsComm,0,0); 

   } 

string GetCommentForOrder() { return(Name_Expert); } 

double GetSizeLot() { return(LotSize); } 
double GetTakeProfitBuy() { return(Ask+longTradeTP*Point); } 
double GetTakeProfitSell() { return(Bid-ShortTradeTP*Point); }
double GetStopLossBuy() { return(Bid-LongTradeStopLoss*Point); }
double GetStopLossSell() { return(Ask+ShortTradeStopLoss*Point); }